//    Copyright (C) 2004 Michael Mahr

//    This file is part of "lesschess".
//
//    "lesschess" is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    "lesschess" is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with "lesschess"; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __chesspiece__
#define __chesspiece__

//the logical part of a chesspiece (it is pretty dumb, because the board contains the logic)

class Chesspiece
{
private:
  int x;//breite
  int y;//hhe

  //can only be set via constructor
  bool white;
  int value; //0 = pawn; 1 = knight; rook = 2; bishop = 3; queen = 4; king = 5;
  
public:
  Chesspiece (bool _white, int _value, int _x, int _y);
  virtual ~Chesspiece();

  int getx();
  int gety();

  void moveto(int _x, int _y);

  int getvalue();
  bool getwhite();

  void hitmove(int _x, int _y);

  virtual void draw();

};


#endif
