//    Copyright (C) 2004 Michael Mahr

//    This file is part of "lesschess".
//
//    "lesschess" is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    "lesschess" is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with "lesschess"; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __smoothvalue__
#define __smoothvalue__

#include <math.h>

//oh my god! - its a smooth value!

//this class uses a "f(x) = x*x" function to move one value smoothly towards the other
//2 advantages:
//1) the function stops smoothing, when the values are equal - no need to redraw forever
//2) the function does not need fixed timeintervals - you can request the smoothed value whenever you want
//(you just have to provide the timeinterval to your last request)

//note: the supplied intervalls have to be a _really_(!) small metric.
//to achieve different smoothing speeds, simply multiply or divide the intervall with a constant value of your choice.

class SmoothValue
{
public:
  SmoothValue();

  //so that you do not need to specify the same value twice.
  SmoothValue(float initvalue);
  void init (float initvalue);

  float target;
  float value;

  void calculate(float interval);
};


#endif
