//    Copyright (C) 2004 Michael Mahr

//    This file is part of "lesschess".
//
//    "lesschess" is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    "lesschess" is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with "lesschess"; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __sps2ascmodel__
#define __sps2ascmodel__

#include "defs.h"
#include "xascmodel.h"
#include <string>
#include <linux/sps2/sps2lib.h>
#include <linux/sps2/sps2tags.h>
#include <linux/sps2/sps2util.h>
#include <math.h>

//this is an experimental class that uses sps2 to output the object

struct AscColor
{
  float r;
  float g;
  float b;
};


class SPS2AscModel
{
private:
  XAscModel * asc;
  
  std::map <unsigned int, AscColor> vertexcolor;
  
  //stores the unbranched data
  unsigned int numfaces;
  float * faces;
  unsigned char * colors; //this is a waste of space
  
  float scale[3];
  float rotate[4];

  unsigned char clamp(float input);
  
public:
  SPS2AscModel(std::string filename, float * _scale, float * _rotate, float * color, float * lightcolor, float * lightorigin);

  virtual ~SPS2AscModel();

  void draw();
  
};

#endif
