//    Copyright (C) 2004 Michael Mahr

//    This file is part of "lesschess".
//
//    "lesschess" is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    "lesschess" is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with "lesschess"; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __xascmodel__
#define __xascmodel__

#include <vector>
#include "ascmodel.h"
#include <string>
#include <math.h>


//all weird transformations that make the model usable for 3D are done here
//may be extended in the future

enum XAscMode
{
  vertexnormals = 1,
  facenormals = 2
};

class XAscModel : public AscModel
{
public:
  XAscModel(std::string _filename, XAscMode mode);

  virtual ~XAscModel();

  std::map<unsigned int, AscVector> facenormals;
  std::map<unsigned int, AscVector> vertexnormals;
};

#endif
